#! /bin/sh

VER=/usr/local/teletimex/version
LOG=/usr/local/teletimex/log
MOD=/etc/modules
TMP=/usr/local/teletimex/tmp
ROM=/usr/local/ttx/log/rom_update.log
APP=/usr/local/ttx/bin/get_flash_version_updt_app.sh

exec 3< $VER

read FL 0<&3
exec 3<&-

CHAR1=`echo $FL | cut -c 1`
CHAR2=`echo $FL | cut -c 2`
CHAR3=`echo $FL | cut -c 3`
CHAR4=`echo $FL | cut -c 4`
CHAR5=`echo $FL | cut -c 5`
BUFF=$CHAR1$CHAR3$CHAR4

if [ $CHAR2 != "." ]; then
	BUFF=$CHAR1$CHAR2$CHAR4$CHAR5
fi

if [ $BUFF -lt 006 ]; then
	mv data/user.dat update/user.dat-
fi

if [ ! -d "/usr/local/ttx/log" ]; then
    mkdir /usr/local/ttx/log
fi

if [ ! -d $TMP ]; then
    mkdir $TMP
fi

if [ ! -f $APP ]; then
    /usr/bin/sudo tar xvfz update/for_ttxupdt_get_flash_version.tar.gz -C /
fi

mv ttx_main update/ttx_main-
mv bin update/bin-
mv defaults update/defaults-
mv update/ttx_main .
mv update/bin .
mv update/defaults .
mv update/ttx_logger .
mv update/settimezone .

if [ -f $MOD ]; then
    fsize=`ls -l $MOD| awk '{print $5}'`
    if [ $fsize -eq 290 ]; then
        /usr/bin/sudo tar xvfz update/modules-update.tar.gz -C /
	fi
fi

/usr/bin/sudo chown teletimex.teletimex $LOG/ttx.log*

/usr/bin/sudo tar xvfz update/chap-update.tar.gz -C /
/usr/bin/sudo tar xvfz update/teletimex.tar.gz -C /
/usr/bin/sudo tar xvfz update/ttx_phs_files.tar.gz -C /
/usr/bin/sudo tar xvfz update/mcr_driver_update.tar.gz -C /

/usr/bin/sudo mv update/fonts.tar.gz /
/usr/bin/sudo mv update/ttx.img.tar.gz /

cd /
/usr/bin/sudo rm -rf /usr/share/fonts/
/usr/bin/sudo tar xvfz fonts.tar.gz; /usr/bin/sudo rm fonts.tar.gz

/usr/bin/sudo tar xvfz ttx.img.tar.gz
/usr/bin/sudo rm ttx.img.tar.gz
/usr/bin/sudo mount /dev/hda1 /boot
/usr/bin/sudo mv ttx.img /boot/boot
/usr/bin/sudo umount /boot
echo "0.12 2010/10/20" > /usr/local/ttx/version

#-- ROM update --
cd /usr/local/teletimex/update
/usr/bin/sudo tar xvfz ttxflash.tgz -C /usr/local/teletimex
/usr/bin/sudo ./unpack_ttx_dir.sh
/usr/bin/sudo ./check_flash_update.sh
if [ $? = 0 ]; then
	/usr/bin/sudo ./do_flash_update.sh
fi
#--------

if [ -f $ROM ]; then
    /usr/bin/sudo chown teletimex.teletimex $ROM
fi

cd /usr/local/teletimex
mv version update/version-
mv update/version .

/usr/bin/sudo /bin/sync
/usr/bin/sudo /bin/sync
/usr/bin/sudo /bin/sync

if [ $BUFF -lt 100 ]; then
    /usr/bin/sudo /sbin/shutdown -r now
    /usr/bin/sudo /bin/sleep 15
fi
