#!/bin/bash

DEBUG_PRINT=0
SCRIPT_VERSION="1.01"
FLASH_UTIL_DIR=/usr/local/ttx/bin/
#debug
#FLASH_UTIL_DIR=$PWD
#end debug
GET_FLASH_VER_UPDT_APP=$FLASH_UTIL_DIR/get_flash_version_updt_app.sh
GET_FLASH_VER_UPDT_ROM=$FLASH_UTIL_DIR/get_flash_version_updt_rom.sh


GOT_VERSION=-1

trap '' INT TERM SIGTSTP

# debug echo
decho()
{
	if [ $DEBUG_PRINT = 1 ]; then
		echo -e $1 | tee -a $ROM_UPDATE_LOG 2>&1
	fi
}

# check_update_file for get_flash_version.sh
check_update_script()
{
   	GOT_VERSION=-1
	if [ -x $1 ]; then
		# delete float point  1.23 -> 123
		GOT_VERSION=`$1 --version | sed -e s/\\\\.//`
    fi
	return 0
}

## entry point

# module auto load
lsmod | grep ttx_flash > /dev/null 2>&1
if [ $? -ne 0 ]; then
	sudo modprobe ttx-flash
fi

# print version
if [ $# -eq 1 ]; then
	if [ $1 == "--version" ]; then
		echo $SCRIPT_VERSION
		exit 0
	else
		echo "[Error] Argument val"
		exit 1
	fi
fi

# get script version
check_update_script $GET_FLASH_VER_UPDT_APP
ver_app=$GOT_VERSION
check_update_script $GET_FLASH_VER_UPDT_ROM
ver_rom=$GOT_VERSION

decho "app"
decho  $ver_app
decho "rom"
decho  $ver_rom

if [ \( $ver_app -eq -1 \) -a \
	 \( $ver_rom -eq -1 \) ]; then
	decho "found both script"
	exit 1
elif [ $ver_app -gt $ver_rom ]; then
	env | grep TTX_GFVER_BETTER_CHECK > /dev/null
	if [ $?  -eq 0 ]; then
		decho "Error userland(script version)"
		exit 1
	else
		decho "run APP side script"
		$GET_FLASH_VER_UPDT_APP
	fi
else
	decho "run ROM side script"
	$GET_FLASH_VER_UPDT_ROM
fi

if [ $? -ne 0 ]; then
	exit 1
else
	exit 0
fi



